#include <sourcemod>
#include <sdktools>
#include <sdktools_sound>
#include <cstrike>
#include <colors>

enum PlayerInfo
{
	pClass,
}

new Player[PlayerInfo][MAXPLAYERS];

new RandomValue;
new Handle:cvRCAK, cvAK;
new ClassCount;

public Plugin:myinfo = 
{ 
    name = "dPI Random", 
    author = "Primo", 
    description = "Играем со случайностью.", 
    version = "1.2", 
} 

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max) 
{ 
	CreateNative("pGetPlayerClass", Native_pGetPlayerClass); 
	CreateNative("pGetClassValue", Native_pGetClassValue);
	CreateNative("pSetClassValue", Native_pSetClassValue);
	CreateNative("pSetPlayerClass", Native_pSetPlayerClass);
	return APLRes_Success; 
} 

//-------- Выполняем, когда плагин запустился
public OnPluginStart() 
{
	cvRCAK = CreateConVar("sm_random_afterkill", "0", "1 - on; 0 - off mode", 0, true, 0.0, true, 1.0);
	cvAK = GetConVarInt(cvRCAK);
	HookEvent("round_start", VErtoe_Round_Start); 
	HookEvent("player_spawn", VErtoe_PlayerSpawn);
	//HookEvent("player_death", VErtoe_PlayerDeath);
	//HookEvent("round_end", VErtoe_Round_End);
	//HookEvent("player_hurt", VErtoe_PlayerHurt);
}

public Native_pGetPlayerClass(Handle:plugin, numParams) return Player[pClass][GetNativeCell(1)]; 
public Native_pSetPlayerClass(Handle:plugin, numParams) return Player[pClass][GetNativeCell(1)] = GetNativeCell(2);
public Native_pGetClassValue(Handle:plugin, numParams) return ClassCount;
public Native_pSetClassValue(Handle:plugin, numParams) return ClassCount = GetNativeCell(1);

//-------- 
//--------  Выполняем, когда раунд начался
public VErtoe_Round_Start(Handle:event, const String:name[], bool:dontBroadcast) 
{
	if(cvAK == 1)
	{
		PrintToChatAll("Всего есть % классов", ClassCount);
		RandomValue = GetRandomInt(1, 5);
		if(RandomValue == 5)
		{
			PrintToChatAll("Активирован режим командной случайности");
			new ClassCT = GetRandomInt(1, ClassCount);
			new ClassT = GetRandomInt(1, ClassCount);
			for (new client=1; client<=GetMaxClients(); client++)
			{
				if(IsClientInGame(client))
				{
					if(GetClientTeam(client) == 3)
					{
						Player[pClass][client] = ClassCT;
					}
					else if(GetClientTeam(client) == 2)
					{
						Player[pClass][client] = ClassT;
					}
				}
			}
		}
	}
} 
 
//-------- 
/*-------- Выполняем, когда раунд закончился
public VErtoe_Round_End(Handle:event, const String:name[], bool:dontBroadcast)
{
	for (new client=1; client<=GetMaxClients(); client++)
	{
		if(IsClientInGame(client)) ViewStatistic(client);
	}
}*/

//-------- 
//-------- Выполняем, когда игрок появился
public VErtoe_PlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast) 
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if(IsClientInGame(client) && IsPlayerAlive(client))
	{
		if(RandomValue != 5) Player[pClass][client] = GetRandomInt(1, ClassCount);
	}
} 
//-------- 
//-------- Выполняем, когда игрок умер
